before_script:
  - |
    apt -y update
    apt -y install unzip curl gnupg2 software-properties-common
    apt -y install build-essential zlib1g-dev libncurses5-dev libgdbm-dev libnss3-dev libssl-dev libreadline-dev libffi-dev wget
    apt -y install lsb-release 
    add-apt-repository ppa:deadsnakes/ppa
    apt -y install python3.8 python3-pip 
  - |
    pip3 install awscliv2  
  - |
    curl -fsSL https://apt.releases.hashicorp.com/gpg | apt-key add -
    apt-add-repository "deb [arch=$(dpkg --print-architecture)] https://apt.releases.hashicorp.com/ $(lsb_release -cs) main"
    apt -y install terraform
    
stages:
  - Test IAC
  - Deploy AWS

Test IAC:
  stage: Test IAC
  image: ubuntu:20.04
  script:
    - cd terraform
    - terraform init -upgrade
    - terraform plan

Deploy to AWS:
  stage: Deploy AWS
  image: ubuntu:20.04
  script:
    - cd terraform
    - terraform init -upgrade
    - echo yes | terraform apply
